<?php
	//////////////////////////////////////////////////////////
	//	CONFIGURATION FILE FOR  phpMyPrepaid		//
	//	edit to suit your instalation			//
	//	C. Carl H. Peterson 2005			//
	//////////////////////////////////////////////////////////

	//////////////////////////////////////////////////////////
	//	First we include a couple of files we need	//
	//////////////////////////////////////////////////////////
        //error_reporting(E_ALL);
	include_once('include/divers/functions.php');
	include_once('include/divers/listcheckbox.php');
	include_once('phpmyprepaid.conf.php');
	include_once ("class/Session.class.php");
	include_once ("class/User.class.php");
	include_once ("class/OreonDatabase.class.php");
	include_once ("class/Oreon.class.php");
	include_once("lang/en.php");

	//////////////////////////////////////////////////////////
	//	Now we set up a couple of variables so we 	//
	//	don't have to hard code them elsewhere		//
	//////////////////////////////////////////////////////////

	$projectName="PHPMyPrepaid"; // <--this is shown at the top of the page
	$Banner="images/banner.png     ";
	$Logo="images/logo.png";
	$images_path="/images";
	$debug=false;
	$general_most_recent_fl= 30;
	$sql_row_limit=40;
	$crypt_method="clear;md5;crypt";
	$apache_file_name="include/template/phpmyprepaid-apache.conf";
	$apache_config_path="/etc/apache2/conf.d/";
	$apache_config_bin_path="/etc/init.d/apache2 restart";
	$firewall_file_name="include/template/chilli.firewall";
	$firewall_config_path="/etc/";
	$firewall_config_bin_path="/etc/chilli.firewall";
    $acctinputoctetsattr="acctinputoctets";
    $acctoutputoctetsattr="acctoutputoctets";
    $use_timezone="1";

	
	//////////////////////////////////////////////////////
	//	SETTINGS FOR UPLOAD AND DOWNLOAD LIMITS			//
	//////////////////////////////////////////////////////
	$sql_date_format= "Y-m-d";
	$sql_accounting_table="radacct";
	$general_accounting_attrs_file="./accounting.attrs";
	$default_pid_passwd="phmpmyprepaidpidpasswd";

	$dateFormatTab="d-m-Y H:i;Y/m/d H:i;Y-m-d H:i";
	$timeCount="Minutes;Hours;Days;Months;Years";
	$octetCount="Mo;Go;To";
	$defaultOctetCount="Go";
	$defaultTimeCount="Minutes";
	
	# Since calculating monthly usage can be quite expensive we make
	# it configurable
	# This is not needed if the monthly limit is not none
	#counter_monthly_calculate_usage: true
	$updownload="64,128,256,512,1024,2048";
	$interfacelist="eth0,eth1,eth2,wlan0,wlan1";
	$differentaccttype="Time,Octets,Expiration";
	$currency="$,€,XPF,AUD,JPY,GBP,CAD";
	$defaultcurrency="$";
	$defaultaccttype="Time";
	$octet_type_tab="Upload;Download;Total";
	$default_octet_type="Total";
	$gateway_list="chillispot;nomadix;freeradius;mikrotik";
	$default_gateway="chillispot";


	//PDF MAIN VALUE
	$pdf_metric="mm;in";
	$operator=":=;=;>;<;==";
	$pdf_paper_size="A4;letter";
	$pdf_font="Arial;Courier;Helvetica;symbol;Times";
	$pdf_font_style="Normal;Bold;Italic";
	$pdf_type_list="None;5160;5161;5162;5163;5164;8600;L7163;CARD";
	$nas_type_list="other;cisco;computone;livingston;tc;max40xx;multitech;netserver;pathras;patton;portslave;usrhiper";

	
	//////////////////////////////////////////////////////////
	// Settings for Access Points				//
	//////////////////////////////////////////////////////////
        /*
        * AP MIB creates an array with the key being displayed in the drop
        * down menu.
        */
        $ap_mib['DBL_2300']="enterprises.99.7.101"; // mib for DBL 2300
        $ap_mib['IE_4457']="enterprises.12560.1.3.2.5.1.1"; // mib for 1100A ver 4457
        $ap_mib['IE_4402']="enterprises.12560.1.3.2.5.1.1"; // mib for 1100A ver 4402
        $ap_mib['IE_4400']="enterprises.12560.1.3.2.5.1.1"; // mib for 1100A ver 4400
        $ap_mib['IE_4480']="enterprises.12560.2.1.1.8.2.1.2"; // mib for 1100A ver 4480

       //General Calculations
	
?>
